
#define _DB_C_
#include "../client.h"
#include "db.h"
#include "form.h"
#include "command.h"
#include "socket.h"
#include "../console.h"
#include <stdio.h>

int obj_search(int id) {
	int i;
	for(i=0;i<object_used ;i++) {
		if(id == object[i].id) {
			return i;
		}
	}
	return MAX_CACHE_NAME;
}

void obj_extra(OBJECT *name) {
	const char *cls;
	char extra[64];
	if((name->cls >= 0 && name->cls <= 23) || (name->cls >= 4008 && name->cls <= 4021)) {
		cls = "chr";
		name->type = OBJ_TYPE_CHR;
		sprintf(extra," %s Job:%s Sex:%s Lv:%d",
			(name->dead_sit == 0 ? "Stand" : (name->dead_sit == 1 ? "Dead" : "Sit")),
			cls_name(name->cls),(name->sex == 1 ? "" : ""),name->lv);
	} else if(name->cls >= 32 && name->cls < 1000) {
		cls = "npc";
		name->type = OBJ_TYPE_NPC;
		extra[0] = 0;
	} else if(name->cls >= 1000 && name->cls <= 2000) {
		cls = "mob";
		name->type = OBJ_TYPE_MOB;
		extra[0] = 0;
	} else {
		cls = "xxx";
		name->type = OBJ_TYPE_UNKNOWN;
		sprintf(extra," Cls:%d",name->cls);
	}
	if(name->chara_name[0]) {
		sprintf(
			name->extra,
			"%s %s%s %s (%d,%d)",
			cls,name->chara_name,extra,chara.mapname,name->pos & 0xFFFF,name->pos >> 16);
	} else {
		sprintf(name->extra,"%s %d%s %s (%d,%d)",cls,name->id,extra,chara.mapname,name->pos & 0xFFFF,name->pos >> 16);
	}
}

const char *obj_getname(HWND hwnd,int id,int cls,char sex,int lv,int pos,int dead_sit) {
	int i;
	static char limit[] = "-limit-";
	for(i=0;i<MAX_CACHE_NAME;i++) {
		if(id == object[i].id) {
			int flag = 0;
			if(cls != -1) { object[i].cls = cls; flag = 1; }
			if(lv  != -1) { object[i].lv  = lv;  flag = 1; }
			if(sex != -1) { object[i].sex = sex; flag = 1; }
			if(pos != -1) { object[i].pos = pos; flag = 1; }
			if(dead_sit != -1) { object[i].dead_sit = dead_sit; flag = 1; }
			if(flag) {
				obj_extra(&object[i]);
			}
			return object[i].chara_name;
		}
	}
	// object[0] ͑Lpɗ\ς
	for(i=1;i<MAX_CACHE_NAME;i++) {
		if(!object[i].id) {
			break;
		}
	}
	if(i == MAX_CACHE_NAME) {
		return limit;
	} else {
		// LbVɖ̂Ŗ₢킹
		char buf[64];
		PACKET *pt = &packet_db[packet_get("getcharnamerequest")];
		memset(&buf,0,pt->len);
		memcpy(&buf[pt->pos[0]],&id,4);
		sock_send(pt->id,&buf,0);

		object[i].id   = id;
		object[i].lv   = lv;
		object[i].cls  = cls;
		object[i].pos  = pos;
		object[i].dead_sit = dead_sit;
		obj_extra(&object[i]);

		if(i != object_used) {
			if(select1_type == UPDATE_OBJECT) {
				SendDlgItemMessage(hwnd,IDC_SELECT,LB_DELETESTRING,i,0);
			}
		} else {
			object_used = i+1;
		}
		if(select1_type == UPDATE_OBJECT) {
			wchar_t buf_w[512];
			MultiByteToWideChar(CP_THREAD_ACP,0,object[i].extra,-1,buf_w,512);
			SendDlgItemMessage(hwnd,IDC_SELECT,LB_INSERTSTRING,i,(LPARAM)buf_w);
		}
		sprintf(object[i].chara_name,"%d",object[i].id);
		return object[i].chara_name;
	}
}

void obj_del(int id,HWND hWnd) {
	int  i;
	// ̂ID:0 ̃IuWFNg邱Ƃ
	for(i=1;i<MAX_CACHE_NAME;i++) {
		if(object[i].id == id) {
			object[i].id             = 0;
			object[i].extra[0]       = 0;
			if(select1_type == UPDATE_OBJECT) {
				SendDlgItemMessage(hWnd,IDC_SELECT,LB_DELETESTRING,i,0);
				SendDlgItemMessage(hWnd,IDC_SELECT,LB_INSERTSTRING,i,(LPARAM)L"-");
			}
			if(id == bot.move.id) {
				// ǐՒIDĂ܂
				bot.move.warp_id   =  id;
				bot.move.warp_flag = 500;
			}
			if(id == bot.attack.id) {
				// U̓G
				bot.attack.id = 0;
			}
		}
	}
}

void party_extra(PARTY *party) {
	char *p = party->extra;
	if(!party->is_leader) { p += sprintf(p,"* "); }
	if(!party->is_online) {
		p += sprintf(p,"(On) ");
	} else {
		p += sprintf(p,"(Off) ");
	}
	p += sprintf(p,"%s ",party->name_chara);
	if(party->hp_max) {
		p += sprintf(p,"HP:% 5u/% 5u ",party->hp,party->hp_max);
	}
	p += sprintf(p,"Map:%s",party->name_map);
	if(party->pos) {
		p += sprintf(p,"(%d,%d)",party->pos & 0xFFFF,party->pos >> 16);
	}
	sprintf(p," ID:%d",party->id);
}

int guild_search(int id) {
	int i;
	for(i=0;i<guild_count;i++) {
		if(id == guild[i].id) {
			return i;
		}
	}
	return MAX_GUILD;
}

void guild_extra(GUILD *guild) {
	char *p = guild->extra;
	if(guild->is_online) {
		p += sprintf(p,"(On) ");
	} else {
		p += sprintf(p,"(Off) ");
	}
	sprintf(
		p,"%s[%s] Sex:%s Job:%s Lv:%d Exp:%d ID:%d",
		guild->name_chara,
		guild_pos[guild->posision].name,
		guild->sex == 1 ? "" : "",
		cls_name(guild->cls),guild->lv,
		guild->exp,
		guild->id
	);
}

void skill_read(void) {
	FILE *fp;
	char line[1024];
	int cmd;
	char *p,*p2;

	console_output("Reading Skill ... ");
	memset(skill_name,0,sizeof(skill_name));
	if( (fp=fopen("db/skill_db.txt","r"))==NULL ){
		MessageBoxA(NULL,"can't read db/skill_db.txt","Skill Error",MB_OK);
		exit(1); return;
	}
	while(fgets(line,1020,fp)){
		if(line[0]=='/' && line[1]=='/') {
			continue;
		}
		cmd = atoi(line);
		if(cmd >= MAX_SKILL) { continue; }
		p = strchr(line,'#');
		if(p == NULL) { continue; }
		p2 = strchr(p+1,'#');
		if(p2 == NULL) { continue; }
		memcpy(skill_name[cmd],p+1,p2-p-1);
		skill_name[cmd][p2-p-1] = 0;
	}
	fclose(fp);
	console_output("Done.\n");
}

void mess_add(HWND hWnd,char *mes) {
	if(mess_max == MAX_MESSAGE) {
		// POP 
		memmove(mess,mess[1],sizeof(mess) - sizeof(mess[0]));
		mess_max--;
		if(select1_type == UPDATE_MESSAGE) {
			// Ō
			SendDlgItemMessage(hWnd,IDC_SELECT,LB_DELETESTRING,mess_max,0);
		}
	}
	strcpy(mess[mess_max++],mes);
	if(select1_type == UPDATE_MESSAGE) {
		// 擪ɑ
		wchar_t buf_w[512];
		MultiByteToWideChar(CP_THREAD_ACP,0,mes,-1,buf_w,512);
		SendDlgItemMessage(hWnd,IDC_SELECT,LB_INSERTSTRING,0,(LPARAM)buf_w);
	}
}

void packet_add(int id,char *name) {
	int i;
	for(i=0;i<MAX_PACKET_DB;i++) {
		if(!packet_name[i].name[0] || !strcmp(packet_name[i].name,name)) {
			break;
		}
	}
	packet_name[i].id = id;
	strcpy(packet_name[i].name,name);
}

int packet_get(char *name) {
	int  i;
	char buf[256];
	for(i=0;i<MAX_PACKET_DB;i++) {
		if(!strcmp(packet_name[i].name,name)) {
			return packet_name[i].id;
		}
	}
	sprintf(buf,"Func %s not found.",name);
	MessageBoxA(NULL,buf,"Socket Error",MB_OK);
	exit(1); return -1;
}

void packet_read(void) {
	FILE *fp;
	char line[1024];
	int cmd,j;
	char *str[32],*p,*str2[32],*p2;

	console_output("Reading Packet ... ");
	if( (fp=fopen("db/packet_db.txt","r"))==NULL ){
		MessageBoxA(NULL,"can't read db/packet_db.txt","Socket Error",MB_OK);
		exit(1); return;
	}
	while(fgets(line,1020,fp)){
		if(line[0]=='/' && line[1]=='/') {
			continue;
		}
		memset(str,0,sizeof(str));
		for(j=0,p=line;j<4 && p;j++){
			str[j]=p;
			p=strchr(p,',');
			if(p) *p++=0;
		}
		if(str[0]==NULL)
			continue;

		cmd=strtol(str[0],(char **)NULL,0);
		if(cmd<=0 || cmd>=MAX_PACKET_DB)
			continue;
		packet_db[cmd].id = cmd;

		if(str[1]==NULL){
			MessageBoxA(NULL,"packet_db: packet len error","Socket Error",MB_OK);
			exit(1); return;
		}
		packet_db[cmd].len = atoi(str[1]);

		if(str[2]==NULL){
			continue;
		}
		packet_add(cmd,str[2]);
		if(str[3]==NULL){
			MessageBoxA(NULL,"packet_db: packet error","Socket Error",MB_OK);
			exit(1); return;
		}
		for(j=0,p2=str[3];p2;j++){
			str2[j]=p2;
			p2=strchr(p2,':');
			if(p2) *p2++=0;
			packet_db[cmd].pos[j]=atoi(str2[j]) - 2;
		}
	}
	fclose(fp);
	console_output("Done.\n");
}

const char *cls_name(int cls) {
	switch(cls) {
	case    0: return "m[rX";
	case    1: return "\[h}";
	case    2: return "}WV";
	case    3: return "A[`[";
	case    4: return "ARCg";
	case    5: return "}[`g";
	case    6: return "V[t";
	case    7: return "iCg";
	case    8: return "v[Xg";
	case    9: return "EBU[h";
	case   10: return "ubNX~X";
	case   11: return "n^[";
	case   12: return "ATV";
	case   14: return "NZC_[";
	case   15: return "N";
	case   16: return "Z[W";
	case   17: return "[O";
	case   18: return "AP~Xg";
	case   19: return "o[h";
	case   20: return "_T[";
	case   22: return "ߏ";
	case   23: return "X[p[m[rX";
	case 4008: return "[hiCg";
	case 4009: return "nCv[Xg";
	case 4010: return "nCEBU[h";
	case 4011: return "zCgX~X";
	case 4012: return "XiCp[";
	case 4013: return "ATVNX";
	case 4015: return "pfB";
	case 4016: return "`sI";
	case 4017: return "vtFbT[";
	case 4018: return "`FCT[";
	case 4019: return "NGC^[";
	case 4020: return "NE";
	case 4021: return "WvV[";
	}
	return "xxx";
}
