
#ifndef _DB_H_
#define _DB_H_

#include <windows.h>

#define MAX_CACHE_NAME	500
#define MAX_PARTY       50
#define MAX_GUILD       50
#define MAX_GUILD_POS   50
#define MAX_PACKET_DB	0x0400
#define MAX_SKILL		500
#define MAX_MESSAGE		200

#define OBJ_TYPE_UNKNOWN 0
#define OBJ_TYPE_NPC 1
#define OBJ_TYPE_MOB 2
#define OBJ_TYPE_CHR 3
#define obj_getname2(a,b) obj_getname(a,b,-1,-1,-1,-1,-1)

#ifndef _DB_C_
#define _DB_C_EX_ extern
#else
#define _DB_C_EX_
#endif

typedef struct {
	char mapname[16];
	long account_id;
	long chara_id;
	long login_id1;
	long login_id2;
	long hp,hpmax,sp,spmax;
	long attack_range;
	int is_dead;
	struct {
		int str_1,str_2;
		int agi_1,agi_2;
		int vit_1,vit_2;
		int int_1,int_2;
		int dex_1,dex_2;
		int luk_1,luk_2;
		int atk_1,atk_2;
		int def_1,def_2;
		int matk_1,matk_2;
		int mdef_1,mdef_2;
		int hit;
		int flee_1,flee_2;
		int critical,aspd;
		int status_point;
	} st;
} CHARA;
_DB_C_EX_ CHARA chara;

typedef struct {
	int   id;
	int   type;
	int   cls;
	int   pos;
	int   lv;
	int   dead_sit;
	char  sex;
	char  chara_name[32];
	char  party_name[32];
	int   guild_id;
	char  guild_name[32];
	char  guild_class[32];
	char  extra[256];
} OBJECT;
_DB_C_EX_ OBJECT object[MAX_CACHE_NAME+1]; // +1 undeflԂ
_DB_C_EX_ int object_used;

typedef struct {
	long id;
	long pos;
	char is_leader;
	char is_online;
	long hp;
	long hp_max;
	char name_map[16];
	char name_chara[32];
	char extra[128];
	struct {
		int imupo;
		int bless;
		int speed;
	} bot;
} PARTY;
_DB_C_EX_ PARTY party[MAX_PARTY]; // +1 undeflԂ
_DB_C_EX_ int party_count;

typedef struct {
	long id;
	char name_chara[32];
//	char is_leader;
	long is_online;
	long cls;
	long exp;
	long lv;
	short sex;
	long posision;
	char extra[128];
} GUILD;
_DB_C_EX_ GUILD guild[MAX_GUILD+1]; // +1 undeflԂ
_DB_C_EX_ int guild_count;

typedef struct {
	char name[32];
} GUILD_POS;
_DB_C_EX_ GUILD_POS guild_pos[MAX_GUILD_POS];

_DB_C_EX_ char skill_name[MAX_SKILL][64];

typedef struct {
	int id;
	int len;
	int pos[10];
} PACKET;
_DB_C_EX_ PACKET packet_db[MAX_PACKET_DB];

typedef struct {
	int id;
	char  name[32];
} PACKET_NAME;
_DB_C_EX_ PACKET_NAME packet_name[MAX_PACKET_DB];

typedef struct {
	short id;
	short target_type;
	short unknown;
	short lv;
	short sp;
	short range;
	char  name[24];
	char  up_flag;
} SKILL;
_DB_C_EX_ SKILL skills[MAX_SKILL];
_DB_C_EX_ int skill_max;

_DB_C_EX_ char mess[MAX_MESSAGE][256];
_DB_C_EX_ int  mess_max;
_DB_C_EX_ char mess_wis_name[32]; // Wisper MO
_DB_C_EX_ char mess_wis_body[256]; // Wisper MO

// ֐Q
void obj_del(int id,HWND hWnd);
int   obj_search(int id);
void  obj_extra(OBJECT *name);
const char *obj_getname(HWND hwnd,int id,int cls,char sex,int lv,int pos,int dead_sit);
void party_extra(PARTY *party);
void guild_extra(GUILD *guild);
int guild_search(int id);
void skill_read(void);
void packet_add(int id,char *name);
int  packet_get(char *name);
void packet_read(void);
const char *cls_name(int cls);
void mess_add(HWND hWnd,char *mes);

#endif
