
#include <tchar.h>
#include <stdio.h>
#include <winsock2.h>
#pragma comment(lib,"ws2_32.lib")

#include "db.h"
#include "../client.h"
#include "socket.h"
#include "../console.h"

static WSADATA  Data;
static SOCKET   svSocket;
static int      debug_flag;

void sock_create(void) {
	int result;
	svSocket = 0;
	result = WSAStartup(MAKEWORD(1,1),&Data);
	if(result != 0) {
		MessageBox(NULL,_T("Winsock Dll Error"),_T("Socket Error"),MB_OK);
		exit(1); return;
	}
	debug_flag = 0;
}

void sock_destroy(void) {
	if(svSocket != 0) {
		sock_close();
	}
	WSACleanup();
}

char* sock_long2ip(unsigned long aa,char *host) {
	unsigned char *p = (unsigned char *)&aa;
	static char ret[32];
	if(p[0] == 192 && p[1] == 168) {
		return host;
	} else if(p[0] == 127 && p[1] == 0) {
		return host;
	} else {
		sprintf(ret,"%d.%d.%d.%d",p[0],p[1],p[2],p[3]);
		return ret;
	}
}

int sock_connect(char *host,int port) {
	int result;
	SOCKADDR_IN svAdress;
	console_outputf("Connecting to %s:%d ... ",host,port);
	if(svSocket != 0) {
		sock_close();
	}
	svAdress.sin_family      = AF_INET;
	svAdress.sin_port        = htons((unsigned short)port);
	svAdress.sin_addr.s_addr = inet_addr(host);
	if(svAdress.sin_addr.s_addr == 0xFFFFFFFF){
		// DNS 
		HOSTENT *temp = gethostbyname(host);
		if(temp == NULL) {
			char buf[256];
			sprintf(buf,"Unknown Host: %s",host);
			MessageBoxA(NULL,buf,"Socket Error",MB_OK);
			exit(1); return 0;
		} else {
			memcpy(&svAdress.sin_addr.s_addr,temp->h_addr_list[0],4);
		}
	}

	svSocket = socket(AF_INET, SOCK_STREAM, 0);
	if(svSocket == INVALID_SOCKET) {
		MessageBox(NULL,_T("Socket Create Error"),_T("Socket Error"),MB_OK);
		exit(1); return 0;
	}

	result = connect(svSocket,(struct sockaddr*)&svAdress,sizeof(svAdress));
	if(result == SOCKET_ERROR) {
		MessageBox(NULL,_T("Server Connect Error"),_T("Socket Error"),MB_OK);
		exit(1); return 0;
	}
	// \PbgmubN[hɂ
	{
		unsigned long mode = 1;
		ioctlsocket(svSocket,FIONBIO,&mode);
	}

	console_output("done.\n");
	return 0;
}

int sock_close(void) {
	if(svSocket != 0) {
		closesocket(svSocket);
	}
	return 0;
}

int sock_send(int type_,void *buf,int len2_) {
	int plus = 2;
	short len;
	short len2 = (short)len2_;
	short type = (short)type_;
	if(type < 0 || type >= MAX_PACKET_DB || packet_db[type].len == 0) {
		char buf[256];
		sprintf(buf,"Unknown packet send : %02x.\n",(unsigned short)type);
		MessageBoxA(NULL,buf,"Socket Error",MB_OK);
		exit(1); return 0;
	}
	sock_send_direct(&type,2);
	len = (short)(packet_db[type].len - 2);
	if(len == -3) {
		len2 = (short)(len2 + 4); // BCC Warning ΍
		sock_send_direct(&len2,2);
		sock_send_direct(buf,len2 - 4);
		len = len2;
		plus = 4;
	} else if(len > 0) {
		sock_send_direct(buf,len);
	}
	if(debug_flag) {
		console_outputf("Send; type: %04x len: % 4d + %d\n",type,len,plus);
	}
	return len;
}

int sock_recv(void *buf,int *len2,int wait) {
	int plus = 2;
	short type,len;
	if(sock_recv_direct(&type,2,wait) == 0) { return 0; }
	if(type < 0 || type >= MAX_PACKET_DB) {
		char buf[256];
		sprintf(buf,"Unknown packet recv : %02x.\n",(unsigned short)type);
		MessageBoxA(NULL,buf,"Socket Error",MB_OK);
		exit(1); return 0;
	}
	len = (short)(packet_db[type].len - 2);
	if(len == -3) {
		sock_recv_direct(&len,2,1);
		len = (short)(len - 4); // BCC Warning ΍
		plus = 4;
	}
	if(len > 0) { sock_recv_direct(buf,len,1); }
	if(len2 != NULL) { *len2 = len; }
	if(debug_flag) {
		console_outputf("Recv; type: %04x len: % 4d + %d\n",type,len,plus);
	}
	return type;
}

// wait
//  0 : Mobt@Ƀf[^ꍇAɖ߂
//      f[^ꍇAǂݎ芮܂ő҂B
//  1 : Mobt@̏ԂɊւ炸AKǂݎ芮܂ő҂
int sock_recv_direct(void *buf,int size,int wait) {
	int count  = 0;
	int result = -99999;
	char *p  = (char *)buf;
	if(!svSocket || size == 0) {
		return 0;
	}
	do {
		if(result != -99999) { Sleep(50); }
		result = recv(svSocket,p,size,0);
		if(result == 0) {
			closesocket(svSocket);
			svSocket = 0;
			MessageBoxA(NULL,"Recv: Socket closed.","Socket Error",MB_OK);
			exit(1); return 0;
		} else if(result > 0) {
			size -= result; p += result;
			wait = 1; // ҂tO𗧂Ă
		}
		if(count++ == 20*20) {
			// 20b̃^CAEg
			closesocket(svSocket);
			svSocket = 0;
			MessageBoxA(NULL,"Recv: TimeOut.","Socket Error",MB_OK);
			exit(1); return 0;
		}
	} while(size && wait && svSocket);
	if(debug_flag) {
		console_outputf("Recv: % 4u Bytes.\n",p - (char*)buf);
		console_dump((char *)buf,p - (char*)buf);
	}
	return p - (char*)buf;
}

int sock_send_direct(void *buf,int size) {
	int result;
	if(!svSocket || size == 0) {
		return 0;
	}
	result = send(svSocket,(char *)buf,size,0);
	if(result == SOCKET_ERROR) {
		/* Socket Closed */
		// int aaa = WSAGetLastError();
		closesocket(svSocket);
		svSocket = 0;
		MessageBoxA(NULL,"Send: Socket closed.","Socket Error",MB_OK);
		exit(1); return 0;
	}
	if(debug_flag) {
		console_outputf("Send: % 4u Bytes.\n",result);
		console_dump((char *)buf,result);
	}
	return 0;
}

void sock_debug(int flag) {
	debug_flag = flag;
}
