
#include <tchar.h>
#include <stdio.h>
#include <windows.h>

#define _CONCOLE_C_
#include "console.h"

static int console_redirect = 0;

FILE *console_log = NULL;
HANDLE console_stdout;
void console_log_start(const char* file){
	console_log = fopen(file,"wt");
}

void console_output(const char *buf) {
	console_outputf("%s",buf);
}

void console_outputf(const char *fmt,... ) {
	char buf[512];
	int  len;
	int  temp;
	va_list data;
	va_start(data,fmt);
	len = vsprintf(buf,fmt,data);
	if(console_log) {
		fwrite(buf,1,len,console_log);
	}
	if(!console_stdout) {
		console_stdout = GetStdHandle(STD_OUTPUT_HANDLE);
	}
	if(console_redirect || WriteConsoleA(console_stdout,buf,len,&temp,NULL) == 0) {
		wchar_t buf2[512];
		if(console_redirect == 0) {
			WriteFile(console_stdout,"\xFF\xFE",2,&temp,NULL);
		}
		console_redirect = 1;
		MultiByteToWideChar(CP_THREAD_ACP,0,buf,-1,buf2,1024);
		console_outputw(buf2);
	}
	va_end(data);
}

void console_outputw(const wchar_t *buf) {
	console_outputwf(_T("%s"),buf);
}

void console_outputwf(const wchar_t *fmt,... ) {
	wchar_t buf[512];
	int  len;
	int  temp;
	va_list data;
	va_start(data,fmt);
	len = vswprintf(buf,fmt,data);
	if(console_log) {
		fwrite(buf,1,len,console_log);
	}
	if(!console_stdout) {
		console_stdout = GetStdHandle(STD_OUTPUT_HANDLE);
	}
	if(console_redirect || WriteConsoleW(console_stdout,buf,len,&temp,NULL) == 0) {
		if(console_redirect == 0) {
			WriteFile(console_stdout,"\xFF\xFE",2,&temp,NULL);
		}
		console_redirect = 1;
		WriteFile(console_stdout,buf,len*2,&temp,NULL);
	}
	va_end(data);
}



int console_input_n(int min,int max) {
	int tmp;
	do {
		console_output("Select Number: ");
		scanf("%d",&tmp);
	} while(tmp < min || tmp > max);
	return tmp;
}

void console_dump(char *buf,int len) {
	int i,j,c;
	char *out_start = buf;
	for(i=0;i<len;i++) {
		if(i % 16 == 0) {
			if(i != 0) {
				console_output(" : ");
				for(j=0;j<16;j++) {
					c = ((unsigned char*)out_start)[j];
					console_outputf("%c",c <= 0x20 ? '.' : c);
				}
				console_output("\n");
				out_start = &buf[i];
			}
			console_outputf("    % 4x : ",i);
		}
		console_outputf("%02x ",((unsigned char*)buf)[i]);
	}
	if(len % 16 != 0) {
		for(i = 0;i<16 - (len % 16);i++) {
			console_output("   ");
		}
		console_output(" : ");
		for(j=0;j<len % 16;j++) {
			c = ((unsigned char*)out_start)[j];
			console_outputf("%c",c <= 0x20 ? '.' : c);
		}
	}
	console_output("\n");
}
