// gmap.cpp : R\[ AvP[Vp̃Gg |Cg̒`
//

#include <tchar.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <memory.h>
#include <direct.h>
#include <windows.h>

#include "io/io.h"
#include "act.h"
#include "rsw.h"
#include "gnd.h"
#include "gat.h"
#include "spr.h"
#include "igun.h"
#include "gmap.h"
#include "vram.h"
#include "md5calc.h"
#include "resource.h"
#include "console.h"

struct gmap_data* gmap_load_platinum(struct io_data* io,const wchar_t *file,struct igun_config *cfg);

struct gmap_data* gmap_load(struct io_data* io,const wchar_t *file,struct igun_config *cfg) {
	return gmap_load_platinum(io,file,cfg);
}

void gmap_output_rsw(struct gmap_data* map,const wchar_t *file_pre);

void gmap_output(struct gmap_data* map,struct io_data* io,const wchar_t *file_) {
	int  i;
	wchar_t file_pre[256];
	wchar_t temp[256];
	wchar_t *p;
	wchar_t curr_dir[512];
	wchar_t file[512];
	char *dir_euc_kr  = "\xc0\xaf\xc0\xfa\xc0\xce\xc5\xcd\xc6\xe4\xc0\xcc\xbd\xba";
	char *dir_unicode = "\x20\xC7\x00\xC8\x78\xC7\x30\xD1\x98\xD3\x74\xC7\xA4\xC2\x00\x00";
	wchar_t dir[16];
	if(map == NULL) { return ; }
	
	wcscpy(file,file_);
	GetCurrentDirectoryW(sizeof(curr_dir),curr_dir);
	p = wcsrchr(file,'\\');
	if(p) {
		*p = 0;
		SetCurrentDirectoryW(file);
		*p = '\\';
		wcscpy(file_pre,p + 1);
	} else {
		wcscpy(file_pre,file);
	}
	p = wcsrchr(file_pre,'.');
	if(p != NULL) { *p = 0; }
	console_outputwf(_T("writing %s\n"),file_pre);
	rsw_output_map(map,io,file_pre);
	gnd_output_map(map,io,file_pre);
	gat_output_map(map,io,file_pre);

	for(i = 0;i < map->layer_count; i++) {
		if(&map->layer[i] == map->movable || &map->layer[i] == map->height) {
			;
		} else if(!map->cfg_cut_texture) {
			// eNX`[̃Jbg͒ʏRs[
			swprintf(temp,_T("texture/%s"),map->layer[i].name_textureW);
			console_outputwf(_T("    writing data/texture/%s\n"),map->layer[i].name_textureW);
			io_copy(io,map->layer[i].name_textureW,temp);
		} else {
			// eNX`[̃JbgLvramgč׍H
			struct vram_data* vram, *vram2 = NULL;
			struct vram_size  size;
			RECT from,to;
			do {
				vram = vram_bmpload_file(io,map->layer[i].name_textureW);
				if(vram == NULL) {
					console_outputwf(_T("    can't read %s\n"),map->layer[i].name_textureW);
					break;
				}
				vram_getsize(vram,&size);
				if(size.size_y == map->chip_height) {
					console_outputwf(_T("    height error %s\n"),map->layer[i].name_textureW);
					break;
				}
				vram2 = vram_alloc(size.size_x,size.size_y - map->chip_height);
				if(vram2 == NULL) break;
				from.top    = map->chip_height;
				from.left   = 0;
				from.right  = size.size_x - 1;
				from.bottom = size.size_y - 1;
				to.top    = 0;
				to.left   = 0;
				to.right  = size.size_x - 1;
				to.bottom = size.size_y - map->chip_height - 1;
				vram_copy(vram,vram2,&from,&to,0,255);
				console_outputwf(
					_T("    writing data/texture/%s (texture cut)\n"),
					map->layer[i].name_textureW
				);
				swprintf(temp,_T("texture/%s"),map->layer[i].name_textureW);
				vram_bmpsave(vram2,io,temp,24);
			} while(0);
			vram_free(vram);
			vram_free(vram2);
		}
	}
	if(map->cfg_dir_unicode) {
		wcscpy(dir,(wchar_t *)dir_unicode);
	} else {
		MultiByteToWideChar(CP_THREAD_ACP,0,dir_euc_kr,-1,dir,16);
	}
	
	// gmap œǂݍ񂾃eNX`p̖ʓ|̂ŁA
	// VɓǂݍŏkŃ}bv쐬
	{
		int size = max(1024 / map->map_width , 1024 / map->map_height) + 1;
		struct vram_data *vram1,*vram2;
		struct vram_size vsize;
		struct gnd_info* gnd;
		RECT from,to;
		int space_x, space_y;
		console_outputwf(_T("creating %s.bmp\n"),file_pre);

		// gnd bmp ɃRo[gāA
		swprintf(temp,_T("%s.gnd"),file_pre);
		gnd = gnd_load(io,temp);
		swprintf(temp,_T("texture/%s/map/%s.bmp"),dir,file_pre);
		gnd_output_bmp(gnd,io,temp,size,0,0,24);
		gnd_free(gnd);

		// ǂݍ1024*1024 ɃTCYāA
		vram1 = vram_bmpload_file(io,temp);
		vram2 = vram_alloc(1024,1024);
		vram_getsize(vram1,&vsize);
		if(vsize.size_x == vsize.size_y) {
			space_x = space_y = 0;
		} else {
			vram_square(vram2,0,0,1023,1023,vram_RGB(255,0,255));
			if(vsize.size_x > vsize.size_y) {
				space_x = 0;
				space_y = (int)(1024 * (1.0 - (double)vsize.size_y / vsize.size_x) / 2 + 0.5);
			} else {
				space_x = (int)(1024 * (1.0 - (double)vsize.size_x / vsize.size_y) / 2 + 0.5);
				space_y = 0;
			}
		}
		from.top    = 0;
		from.left   = 0;
		from.right  = vsize.size_x - 1;
		from.bottom = vsize.size_y - 1;

		to.top    = space_y;
		to.left   = space_x;
		to.right  = 1023 - space_x;
		to.bottom = 1023 - space_y;
		vram_copy(vram1,vram2,&from,&to,0,255);
		vram_free(vram1);

		// ŌYɏk
		vram1 = vram_resample(vram2);
		vram_free(vram2);
		vram_bmpsave(vram1,io,temp,24);
		vram_free(vram1);
	}
	SetCurrentDirectoryW(curr_dir);
}

void gmap_free(struct gmap_data* map) {
	if(map == NULL) { return ; }
	if(map->layer != NULL) {
		int i;
		for(i=0;i<map->layer_count;i++) {
			free(map->layer[i].mem);
			free(map->layer[i].name_textureW);
			vram_free(map->layer[i].texture);
		}
		free(map->layer);
		free(map->cells);
	}
	free(map);
}

void gmap_height(struct gmap_data* map,struct gmap_height* cell,int x,int y) {
	if(map->height == NULL) {
		cell->z_lt = cell->z_lb = cell->z_rt = cell->z_rb = 0;
	} else if(map->cfg_flag_expert) {
		// GLXp[g[h
		int pos = (y*2) * (map->map_width*2) + (x*2);
		short *cell_height = map->height->cell;
		cell->z_lt = (float)cell_height[pos];
		cell->z_lb = (float)cell_height[pos + (map->map_width * 2)];
		cell->z_rt = (float)cell_height[pos + 1];
		cell->z_rb = (float)cell_height[pos + (map->map_width * 2)+ 1];

		// ␳
		cell->z_lt = cell->z_lt * map->cfg_height_calc_mul + map->cfg_height_calc_add;
		cell->z_lb = cell->z_lb * map->cfg_height_calc_mul + map->cfg_height_calc_add;
		cell->z_rt = cell->z_rt * map->cfg_height_calc_mul + map->cfg_height_calc_add;
		cell->z_rb = cell->z_rb * map->cfg_height_calc_mul + map->cfg_height_calc_add;
	} else {
		int pos = y * map->map_width + x;
		short *cell_height = map->height->cell;
		if(y == map->map_height - 1 && x == map->map_width - 1) {
			// ẼZ
			cell->z_lb = cell->z_rb = cell->z_rt = 0;
			cell->z_lt = (float)cell_height[pos];
		} else if(y == map->map_height - 1) {
			// ԉ̍s
			cell->z_lb = cell->z_rb = 0;
			cell->z_lt = (float)cell_height[pos];
			cell->z_rt = (float)cell_height[pos + 1];
		} else if(x == map->map_width - 1) {
			// ԉE̍s
			cell->z_rt = cell->z_rb = 0;
			cell->z_lt = (float)cell_height[pos];
			cell->z_lb = (float)cell_height[pos + map->map_width];
		} else {
			// ʂ̃Z
			cell->z_lt = (float)cell_height[pos];
			cell->z_lb = (float)cell_height[pos + map->map_width];
			cell->z_rt = (float)cell_height[pos + 1];
			cell->z_rb = (float)cell_height[pos + map->map_width + 1];
		}
		// ␳
		cell->z_lt = cell->z_lt * map->cfg_height_calc_mul + map->cfg_height_calc_add;
		cell->z_lb = cell->z_lb * map->cfg_height_calc_mul + map->cfg_height_calc_add;
		cell->z_rt = cell->z_rt * map->cfg_height_calc_mul + map->cfg_height_calc_add;
		cell->z_rb = cell->z_rb * map->cfg_height_calc_mul + map->cfg_height_calc_add;
	}
}

struct gmap_data* gmap_conf_data;

BOOL CALLBACK gmap_conf_proc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam) {
	char buf[256];
	switch( uMsg ) {
	case WM_INITDIALOG:
		// cfg_height_calc_mul
		sprintf(buf,"%.2f",gmap_conf_data->cfg_height_calc_mul);
		SetDlgItemTextA(hwndDlg,GMAP_CALC_MUL,buf);
		// cfg_height_calc_add
		sprintf(buf,"%.2f",gmap_conf_data->cfg_height_calc_add);
		SetDlgItemTextA(hwndDlg,GMAP_CALC_ADD,buf);
		// cfg_cut_texture
		if(gmap_conf_data->cfg_cut_texture) {
			CheckDlgButton(hwndDlg,GMAP_TEXTURE_CUT,BST_CHECKED);
		} else {
			CheckDlgButton(hwndDlg,GMAP_TEXTURE_CUT,BST_UNCHECKED);
		}
		return 0;
		break;
	case WM_COMMAND:
	case WM_CLOSE:
		if(uMsg == WM_CLOSE || (uMsg == WM_COMMAND && LOWORD(wParam) == IDOK)) {
			// cfg_height_calc_mul
			GetDlgItemTextA(hwndDlg,GMAP_CALC_MUL,buf,255);
			gmap_conf_data->cfg_height_calc_mul = (float)atof(buf);
			// cfg_height_calc_add
			GetDlgItemTextA(hwndDlg,GMAP_CALC_ADD,buf,255);
			gmap_conf_data->cfg_height_calc_add = (float)atof(buf);
			// cfg_cut_texture
			if(IsDlgButtonChecked(hwndDlg,GMAP_TEXTURE_CUT) == BST_CHECKED) {
				gmap_conf_data->cfg_cut_texture = 1;
			} else {
				gmap_conf_data->cfg_cut_texture = 0;
			}
			if(IsDlgButtonChecked(hwndDlg,GMAP_FLAG_EXPERT) == BST_CHECKED) {
				gmap_conf_data->cfg_flag_expert = 1;
			} else {
				gmap_conf_data->cfg_flag_expert = 0;
			}
			if(IsDlgButtonChecked(hwndDlg,GMAP_DIR_UNICODE) == BST_CHECKED) {
				gmap_conf_data->cfg_dir_unicode = 1;
			} else {
				gmap_conf_data->cfg_dir_unicode = 0;
			}
			EndDialog(hwndDlg,0);
		}
		break;
	}
	return 0;
}

void gmap_conf(struct gmap_data* map,struct igun_config *cfg) {
	int resource = (cfg->locate == LANG_JAPANESE ? GMAP_CONFIG_JP : GMAP_CONFIG_EN);
	gmap_conf_data = map;
	DialogBoxA(NULL,(LPCSTR)MAKEINTRESOURCE(resource),NULL,gmap_conf_proc);
	gmap_conf_data = NULL;
}

// MAP File Loadrer for Platinum v1.52b
//
//     o̓t@CɃC[ƃeNX`[̃t@ĈƁA
//     mmiogƎ肱ڂNiƂAgȂĵŁA
//     ͂Ŏ蔲RIFFǂݍ݃[`HڂɂȂ܂ƂB
//     d\ɂȂĂȂĐEEEB

int gmap_load_platinum_layer(struct gmap_data* map,const wchar_t *file,struct io_data* io,struct gmap_layer* lay,int layers);

struct gmap_data* gmap_load_platinum(struct io_data* io,const wchar_t *file,struct igun_config *cfg) {
	char buf[256];
	long layers;
	struct io_fp *fp;
	struct gmap_data* map;
	
	console_outputwf(_T("reading %s (Platinum v1.52b / 1.68f)\n"),file);

	fp = io_read_open(io,file);
	if(fp == NULL) { return NULL; }
	io_read(fp,buf,12); //	RIFF[size]UMF_ ̓ǂݍ
	if(memcmp(buf,"RIFF",4) || memcmp(&buf[8],"UMF_",4)) {
		console_outputf("    map_load_platinum : Unsupported File\n");
		io_close(fp); return NULL;
	}
	map = (struct gmap_data *)calloc(sizeof(struct gmap_data),1);
	if(map == NULL) { return NULL; }

	// Wݒ̏
	map->cfg_height_calc_add = 0;
	map->cfg_height_calc_mul = -1;
	map->cfg_cut_texture = 0;
	map->cfg_flag_expert = 0;
	// ݒ肷
	if(cfg != NULL) {
		gmap_conf(map,cfg);
	}

	while(1) {
		char chunk_id[5];
		int  chunk_size;
		long temp;
		if(io_read(fp,chunk_id,4) != 4) {
			io_close(fp);
			// C[Ɠǂݍ߂Ă邩mF
			if(map->layer == NULL || layers != map->layer_count) {
				gmap_free(map); map = NULL; return NULL;
			}
			// GLXp[g[h̕␳
			if(map->cfg_flag_expert) {
				map->map_width  = map->map_width  / 2;
				map->map_height = map->map_height / 2;
			}
			return map;
		}
		chunk_id[4] = 0;
		io_read(fp,&chunk_size,4);

		if(chunk_size % 2 == 1) { chunk_size++; }

		if(!strcmp(chunk_id,"Ver_")) {
			io_read(fp,&temp,sizeof(long)); chunk_size -= sizeof(long);
			if(temp != 0x62020501 && temp != 0x66010601) {
				console_outputf("    Unknown Version: %08x\n",temp);
				io_close(fp); gmap_free(map); return NULL;
			}
		} else if(!strcmp(chunk_id,"UMFh")) {
			io_read(fp,map,20); chunk_size -= 20;
			if(map->layer != NULL) {
				console_outputf("    Double UMFh\n");
				io_close(fp); gmap_free(map); return NULL;
			}
			map->layer = (struct gmap_layer *)calloc(map->layer_count,sizeof(struct gmap_layer));
			if(map->layer == NULL) {
				io_close(fp); gmap_free(map); return NULL;
			}
			map->cells = (long*)calloc(map->map_width * map->map_height,sizeof(long));
			layers = 0;
		} else if(!strcmp(chunk_id,"LAY1")) {
			// Platinum v1.52b
			struct gmap_layer* lay = &map->layer[layers];
			char *p;
			lay->mem = (char *)malloc(chunk_size);
			if(lay->mem == NULL) {
				io_close(fp); gmap_free(map); return NULL;
			}
			p = lay->mem;

			io_read(fp,p,chunk_size); chunk_size = 0;

			lay->name_layer    = p; p += strlen(p) + 1;
			lay->name_textureA = p; p += strlen(p) + 1;
			lay->depth         = *(p++);
			lay->cell          = (short *)p;
			lay->name_textureW = malloc(strlen(lay->name_textureA) * 2 * sizeof(wchar_t) + 16);
			MultiByteToWideChar(CP_THREAD_ACP,0,lay->name_textureA,-1,lay->name_textureW,1024);
			if(gmap_load_platinum_layer(map,file,io,lay,layers)) {
				io_close(fp); gmap_free(map); return NULL;
			}
			layers++;
		} else if(!strcmp(chunk_id,"LIST")) {
			// Platinum v1.68f
			struct gmap_layer* lay = &map->layer[layers];
			char *p;
			char *lay_name_end = NULL;
			char *lay_text_end = NULL;
			lay->mem = (char *)malloc(chunk_size);
			if(lay->mem == NULL) {
				io_close(fp); gmap_free(map); return NULL;
			}
			p = lay->mem;

			io_read(fp,p,chunk_size);
			if(memcmp(lay->mem,"LAY_",4)) {
				// sLIST
				io_close(fp); gmap_free(map); return NULL;
			}
			chunk_size -= 4; p += 4;

			while(chunk_size > 0) {
				int chunk_size_sub;
				if(!memcmp(p,"LSTR",4)) {
					chunk_size -= 4; p += 4;
					chunk_size_sub = *(long*)p;
					chunk_size -= 4; p += 4;
					if(chunk_size_sub % 2 == 1) chunk_size_sub++;
					lay->name_layer = p;
					p += chunk_size_sub; chunk_size -= chunk_size_sub;
					lay_name_end = p;
				} else if(!memcmp(p,"PSTR",4)) {
					chunk_size -= 4; p += 4;
					chunk_size_sub = *(long*)p;
					chunk_size -= 4; p += 4;
					if(chunk_size_sub % 2 == 1) chunk_size_sub++;
					lay->name_textureA = p;
					p += chunk_size_sub; chunk_size -= chunk_size_sub;
					lay_text_end = p;
				} else if(!memcmp(p,"LDAT",4)) {
					chunk_size -= 4; p += 4;
					chunk_size_sub = *(long*)p;
					chunk_size -= 4; p += 4;
					if(chunk_size_sub % 2 == 1) chunk_size_sub++;
					if(chunk_size_sub != map->map_width * map->map_height * 2) {
						// TCYႤ̂Ŗ
						console_outputf("    map_load_platinum : Unsupported layer format\n");
						io_close(fp); gmap_free(map); return NULL;
					}
					lay->cell = (short*)p;
					p += chunk_size_sub; chunk_size -= chunk_size_sub;
				} else {
					chunk_size -= 4; p += 4;
					chunk_size_sub = *(long*)p;
					chunk_size -= 4; p += 4;
					if(chunk_size_sub % 2 == 1) chunk_size_sub++;
					p += chunk_size_sub; chunk_size -= chunk_size_sub;
				}
			}
			if(lay_name_end) *(lay_name_end) = 0;
			if(lay_text_end) *(lay_text_end) = 0;
			if(lay->name_textureA == NULL) lay->name_textureA = "";
			lay->name_textureW = malloc(strlen(lay->name_textureA) * 2 * sizeof(wchar_t) + 16);
			MultiByteToWideChar(CP_THREAD_ACP,0,lay->name_textureA,-1,lay->name_textureW,1024);
			if(gmap_load_platinum_layer(map,file,io,lay,layers)) {
				io_close(fp); gmap_free(map); return NULL;
			}
			layers++;
		}
		if(chunk_size) {
			io_seek(fp,io_tell(fp) + chunk_size);
		}
	}
}

int gmap_load_platinum_layer(struct gmap_data* map,const wchar_t *file_,struct io_data* io,struct gmap_layer* lay,int layers) {
	console_outputf("    reading layer[%d] name:%s texture:%s\n",layers,lay->name_layer,lay->name_textureA);
	if(lay->name_layer && !strcmp(lay->name_layer,"_movable")) {
		if(map->movable) {
			console_outputf("    Err: Double layer [_movable]\n");
			return 1;
		}
		map->movable = lay;
	} else if(lay->name_layer && !strcmp(lay->name_layer,"_height")) {
		if(map->height) {
			console_outputf("    Err: Double layer[_height]\n");
			return 1;
		}
		map->height  = lay;
	} else  {
		// eNX`[̓ǂݍ
		wchar_t file[1024];
		wchar_t *p  = wcsrchr(file_,'\\');
		if(p == NULL) p = wcsrchr(file_,'/');
		if(p) {
			memcpy(file,file_,(p - file_ + 1) * sizeof(short));
			wcscpy(file + (p - file_ + 1),lay->name_textureW);
		} else {
			wcscpy(file,lay->name_textureW);
		}
		lay->texture = vram_bmpload_file(io,file);
		if(lay->texture == NULL) {
			console_outputwf(_T("    texture %s can't open.\n"),lay->name_textureW);
			return 1;
		}
		vram_getsize(lay->texture,&lay->texture_size);
		// eNX`̃Jbgw肳Ă鎞ɂ̓TCY炷
		if(map->cfg_cut_texture) {
			lay->texture_size.size_y -= map->chip_height;
		}
		if(
			lay->texture_size.size_x < 0 ||
			lay->texture_size.size_y < 0 ||
			lay->texture_size.size_x % map->chip_width || 
			lay->texture_size.size_y % map->chip_height
		) {
			console_outputf(
				"    texture %s size error chip:%d x %d texture: %d x %d\n",
				lay->name_textureA,map->chip_width,map->chip_height,
				lay->texture_size.size_x,lay->texture_size.size_y
			);
			return 1;
		}
		lay->tiles_x = lay->texture_size.size_x / map->chip_width;
		lay->tiles_y = lay->texture_size.size_y / map->chip_height;

		// Z肳
		if(map->layer_bitcount == 8) {
			int max  = map->map_height * map->map_width;
			short *p = (short *)lay->cell;
			int i;
			for(i = 0; i < max ; i++) {
				if(*p) {
					map->cells[i] = ((*p / 16) * 256 + *p % 16) | (layers << 16);
				}
				p++;
			}
		} else if(map->layer_bitcount == 16) {
			int max  = map->map_height * map->map_width;
			short *p = (short *)lay->cell;
			int i;
			for(i = 0; i < max ; i++) {
				if(*p) {
					map->cells[i] = *p | (layers << 16);
				}
				p++;
			}
		}
		lay->active_layer_index = map->active_layers++;
	}
	return 0;
}

int  gmap_conv_platinum_layer(struct gmap_data* map,char *layer_name,short *cell_1,struct io_fp *fp2) {
	int x,y;
	short *cell_2 = calloc(map->map_width * map->map_height,4 * sizeof(short));
	if(!strcmp(layer_name,"_height")) {
		struct gmap_height cell;
		for(y = 0;y < map->map_height; y++) {
			for(x = 0;x < map->map_width; x++) {
				gmap_height(map,&cell,x,y);
				cell_2[(x*2)     + (map->map_width * 2) * (y*2)]   = (int)(cell.z_lt * -1);
				cell_2[(x*2)     + (map->map_width * 2) * (y*2+1)] = (int)(cell.z_lb * -1);
				cell_2[(x*2 + 1) + (map->map_width * 2) * (y*2)]   = (int)(cell.z_rt * -1);
				cell_2[(x*2 + 1) + (map->map_width * 2) * (y*2+1)] = (int)(cell.z_rb * -1);
			}
		}
	} else  {
		for(y = 0;y < map->map_height; y++) {
			for(x = 0;x < map->map_width; x++) {
				cell_2[(x*2) + (map->map_width * 2) * (y*2)] = 
					cell_1[x + map->map_width * y];
			}
		}
	}
	io_write(fp2,cell_2,sizeof(short) * map->map_height * map->map_width * 4);
	free(cell_2);
	return 0;
}

void gmap_conv_platinum(struct io_data *io,const wchar_t *file) {
	struct gmap_data* map = gmap_load_platinum(io,file,0);
	struct io_fp *fp1,*fp2;
	wchar_t out_file[256];
	char buf[65536];

	if(map == NULL) {
		return;
	}
	swprintf(out_file,_T("%s_conv.ppj"),file);
	console_outputwf(_T("writing %s\n"),out_file);
	fp1 = io_read_open(io,file);
	fp2 = io_write_open(io,out_file);
	if(!fp1 || !fp2) {
		if(fp1) io_close(fp1);
		if(fp2) io_close(fp2);
		return;
	}
	//	RIFF[size]UMF_
	io_read(fp1,buf,12); 
	io_write(fp2,buf,12);
	while(1) {
		char chunk_id[5];
		int  chunk_size;
		int  chunk_read;
		if(!io_read(fp1,chunk_id,4)) {
			chunk_size = io_tell(fp2) - 8;
			io_seek(fp2,4);
			io_write(fp2,&chunk_size,4);
			io_close(fp1);
			io_close(fp2);
			gmap_free(map);
			return;
		}
		chunk_id[4] = 0;
		io_write(fp2,chunk_id,4);
		io_read(fp1,&chunk_size,4);

		if(!strcmp(chunk_id,"UMFh")) {
			io_read(fp1,buf,20);
			*(int*)(buf)     = (*(int*)(buf))     * 2;	// map_width
			*(int*)(buf + 4) = (*(int*)(buf + 4)) * 2;	// map_height
			io_write(fp2,&chunk_size,4);
			io_write(fp2,buf,20);
			chunk_read = 20;
		} else if(!strcmp(chunk_id,"LAY1")) {
			int  i;
			char *p = (char *)malloc(chunk_size);
			char *mem = p;
			if(mem == NULL) {
				gmap_free(map);
				free(mem);
				io_close(fp1); io_close(fp2);
				return;
			}

			io_read(fp1,p,chunk_size);
			i = chunk_size + map->map_height * map->map_width * 3 * sizeof(short);
			io_write(fp2,&i,sizeof(int));
			chunk_read = chunk_size;

			p += strlen(p) + 1; // name_layer
			p += strlen(p) + 1; // name_texture
			p++;				// depth
			io_write(fp2,mem,p-mem);
			gmap_conv_platinum_layer(map,mem,(short*)p,fp2);
			free(mem);
		} else if(!strcmp(chunk_id,"LIST")) {
			int  i;
			char *p = (char *)malloc(chunk_size);
			char *mem = p;
			char layer_name[256];
			if(mem == NULL) {
				gmap_free(map);
				free(mem);
				io_close(fp1); io_close(fp2);
				return;
			}

			layer_name[0] = 0;

			io_read(fp1,p,chunk_size);
			i = chunk_size + map->map_height * map->map_width * 3 * sizeof(short);
			io_write(fp2,&i,sizeof(int));
			chunk_read = chunk_size;

			io_write(fp2,p,4); chunk_size -= 4; p += 4;

			while(chunk_size > 0) {
				int chunk_size_sub;
				if(!memcmp(p,"LDAT",4)) {
					io_write(fp2,p,4); chunk_size -= 4; p += 4;
					chunk_size_sub = *(long*)p;
					i = chunk_size_sub + map->map_height * map->map_width * 3 * sizeof(short);
					io_write(fp2,&i,4); chunk_size -= 4; p += 4;
					if(chunk_size_sub % 2 == 1) chunk_size_sub++;
					gmap_conv_platinum_layer(map,layer_name,(short*)p,fp2);
					p += chunk_size_sub; chunk_size -= chunk_size_sub;
				} else if(!memcmp(p,"LSTR",4)) {
					io_write(fp2,p,4); chunk_size -= 4; p += 4;
					chunk_size_sub = *(long*)p;
					io_write(fp2,p,4); chunk_size -= 4; p += 4;
					memcpy(layer_name,p,chunk_size_sub);
					layer_name[chunk_size_sub] = 0;
					if(chunk_size_sub % 2 == 1) chunk_size_sub++;
					io_write(fp2,p,chunk_size_sub); p += chunk_size_sub; chunk_size -= chunk_size_sub;
				} else {
					io_write(fp2,p,4); chunk_size -= 4; p += 4;
					chunk_size_sub = *(long*)p;
					io_write(fp2,p,4); chunk_size -= 4; p += 4;
					if(chunk_size_sub % 2 == 1) chunk_size_sub++;
					io_write(fp2,p,chunk_size_sub); p += chunk_size_sub; chunk_size -= chunk_size_sub;
				}
			}
			chunk_size = chunk_read;
			free(mem);
		} else {
			io_write(fp2,&chunk_size,4);
			chunk_read = 0;
		}
		if(chunk_size & 1) {
			chunk_size++;
		}
		if(chunk_size != chunk_read) {
			io_read(fp1,buf,chunk_size - chunk_read);
			io_write(fp2,buf,chunk_size - chunk_read);
		}
	}
}
