#ifndef _GMAP_H_
#define _GMAP_H_

#include "vram.h"

struct gmap_data* gmap_load(struct io_data* io,const wchar_t *file,struct igun_config *cfg);
void gmap_free(struct gmap_data* map);
void gmap_output(struct gmap_data* map,struct io_data* io,const wchar_t *file);
void gmap_conv_platinum(struct io_data *io,const wchar_t *file);

struct gmap_height {
	float z_lb; // 
	float z_rb; // E
	float z_lt; // 
	float z_rt; // E
};

void gmap_height(struct gmap_data* map,struct gmap_height* height,int x,int y);

struct gmap_layer {
	char  *mem;

	short   *cell;
	char    *name_textureA;
	wchar_t *name_textureW;
	char  *name_layer;
	char depth;
	struct vram_data* texture;
	struct vram_size  texture_size;
	int tiles_x;
	int tiles_y;
	int active_layer_index;
};

struct gmap_data {
	int map_width;
	int map_height;
	int chip_width;
	int chip_height;
	unsigned char layer_count;
	unsigned char layer_bitcount;
	char dummy[2];
	struct gmap_layer *layer;
	struct gmap_layer *height;
	struct gmap_layer *movable;
	long *cells;
	int   active_layers;
	int   cfg_cut_texture;		// ԏ̃eNX`[
	float cfg_height_calc_mul;	// vZ *
	float cfg_height_calc_add;	// vZ +
	int   cfg_flag_expert;		// GLXp[g[h
	int   cfg_dir_unicode;		// tH_Unicode ō쐬
};

#endif
