
#include <windows.h>
struct io_data {
	struct io_grf_data* read_grf;
	struct io_grf_data* write_grf;
};

#define IO_FP_READ  0
#define IO_FP_WRITE 1

struct io_fp {
	int     mode;
	struct io_data *io;
	wchar_t filename[256];
	char*   buf_data;
	int     buf_len;
	int     buf_pos;
	int     buf_max;
};

struct io_find {
	struct	io_data* io;
	int		 end;
	wchar_t  expr[256];
	int		 pos;
	HANDLE				find_handle;
	WIN32_FIND_DATAW	find_data;
};

int io_zlib_encode(char *dest, unsigned long* destLen, const char* source, unsigned long sourceLen);
int io_zlib_decode(char *dest, unsigned long* destLen, const char* source, unsigned long sourceLen);
char* io_read_all(struct io_data* io,const wchar_t* file,int *len);
int   io_write_all(struct io_data* io,const wchar_t* file,void *data,int len);

int   io_size(struct io_data* io,const wchar_t* file);
struct io_data* io_create(void);
void io_delete(struct io_data* io);
void io_init(void);
void io_final(void);
struct io_find *io_find_start(struct io_data* io,const wchar_t *expr);
const wchar_t *io_find_next(struct io_find *find);
void io_find_end(struct io_find *find);

wchar_t* io_mbcs_to_unicode(struct io_data* io,wchar_t *buf1,const char *buf2);
char* io_unicode_to_mbcs(struct io_data* io,char *buf1,const wchar_t *buf2);

struct io_fp* io_read_open(struct io_data* io,const wchar_t *file);
struct io_fp* io_write_open(struct io_data* io,const wchar_t *file);
int io_read(struct io_fp *fp,void *buf,int len);
int io_write(struct io_fp *fp,void *buf,int len);
int io_seek(struct io_fp *fp,int pos);
int io_close(struct io_fp *fp);
int io_tell(struct io_fp *fp);
int io_printfWA(struct io_fp* fp,const wchar_t *format, ...);
void io_copy(struct io_data* io,const wchar_t *from,const wchar_t *to);

int io_read_grf(struct io_data* io,const wchar_t *file);

