/*********************************************************************
 *
 *		Ragnarok Online Emulator : grfio.c -- grf file I/O Module
 *--------------------------------------------------------------------
 *		special need library : zlib
 *********************************************************************
 *	$Id: grfio.c,v 1.4 2003/11/10 23:32:44 jmb Exp $
 *
 *	2002/12/18 ... 
 *	2003/01/23 ... R[hC
 *	2003/02/01 ... LocalFileyѕGRF`FbNǉ,ÍǏ
 *	2003/02/02 ... grfĂ~܂Ȃ悤ɏC
 *	2003/02/02 ... grfǂݍݎwォǉł悤ɏC(grfio_add֐ǉ)
 *	2003/02/03 ... grfio_resourcecheckAGgǉ@C
 *	2003/02/05 ... grfio_init̕ύX
 *	2003/02/23 ... [Jt@C`FbNGRFIO_LOCALŃXCb`(ftH@\Off)
 *      2003/10/21  NCAg̃f[^ǂނ悤ɂB
 *	2003/11/10 ... Ready new grf format.
 *	2003/11/11 ... version check fix & bug fix
 */

#include <tchar.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>

#include "io.h"
#include "io_grf.h"
#include "io_file.h"
#include "../console.h"

//----------------------------
//	file entry table struct
//----------------------------
typedef struct {
	int 	srclen;				// compressed size
	int		srclen_aligned;		// 
	int		declen;				// original size
	int		srcpos;
	short	next;
	char	cycle;
	char	type;
	wchar_t	fn[128-4*5];		// file name
} FILELIST;
// gentry ... 0  :[Jt@C擾
//            1>=:gentry_table[gentry-1]̃\[Xt@C擾
//            1<=:[Jt@C`FbN
//                   L0ɍăZbgĈȍ~[Jt@C擾
//                   Ε]čăZbgA1>=Ɠ\[Xt@C擾

// FILELIST.gentrycharŒ`Ă̂grfio_addŒǉł127R܂łɂȂ܂
#define	GENTRY_LIMIT	127
#define	FILELIST_LIMIT	32768	// ,_2G

struct io_grf_data {
	struct io_file *file;
	int  grf_version;
	int  grf_size;
	FILELIST *filelist;
	int	filelist_entrys;
	int	filelist_maxentry;
	int filelist_hash[256];
};

//----------------------------
//	grf decode data table
//----------------------------
static unsigned char BitMaskTable[8] = {
	0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01
};

static char	BitSwapTable1[64] = {
	58, 50, 42, 34, 26, 18, 10,  2, 60, 52, 44, 36, 28, 20, 12,  4,
	62, 54, 46, 38, 30, 22, 14,  6, 64, 56, 48, 40, 32, 24, 16,  8,
	57, 49, 41, 33, 25, 17,  9,  1, 59, 51, 43, 35, 27, 19, 11,  3,
	61, 53, 45, 37, 29, 21, 13,  5, 63, 55, 47, 39, 31, 23, 15,  7
};
static char	BitSwapTable2[64] = {
	40,  8, 48, 16, 56, 24, 64, 32, 39,  7, 47, 15, 55, 23, 63, 31,
	38,  6, 46, 14, 54, 22, 62, 30, 37,  5, 45, 13, 53, 21, 61, 29,
	36,  4, 44, 12, 52, 20, 60, 28, 35,  3, 43, 11, 51, 19, 59, 27,
	34,  2, 42, 10, 50, 18, 58, 26, 33,  1, 41,  9, 49, 17, 57, 25
};
static char	BitSwapTable3[32] = {
	16,  7, 20, 21, 29, 12, 28, 17,  1, 15, 23, 26,  5, 18, 31, 10,
     2,  8, 24, 14, 32, 27,  3,  9, 19, 13, 30,  6, 22, 11,  4, 25
};

static unsigned char NibbleData[4][64]={
	{
		0xef, 0x03, 0x41, 0xfd, 0xd8, 0x74, 0x1e, 0x47,  0x26, 0xef, 0xfb, 0x22, 0xb3, 0xd8, 0x84, 0x1e,
		0x39, 0xac, 0xa7, 0x60, 0x62, 0xc1, 0xcd, 0xba,  0x5c, 0x96, 0x90, 0x59, 0x05, 0x3b, 0x7a, 0x85,
		0x40, 0xfd, 0x1e, 0xc8, 0xe7, 0x8a, 0x8b, 0x21,  0xda, 0x43, 0x64, 0x9f, 0x2d, 0x14, 0xb1, 0x72,
		0xf5, 0x5b, 0xc8, 0xb6, 0x9c, 0x37, 0x76, 0xec,  0x39, 0xa0, 0xa3, 0x05, 0x52, 0x6e, 0x0f, 0xd9,
	}, {
		0xa7, 0xdd, 0x0d, 0x78, 0x9e, 0x0b, 0xe3, 0x95,  0x60, 0x36, 0x36, 0x4f, 0xf9, 0x60, 0x5a, 0xa3,
		0x11, 0x24, 0xd2, 0x87, 0xc8, 0x52, 0x75, 0xec,  0xbb, 0xc1, 0x4c, 0xba, 0x24, 0xfe, 0x8f, 0x19,
		0xda, 0x13, 0x66, 0xaf, 0x49, 0xd0, 0x90, 0x06,  0x8c, 0x6a, 0xfb, 0x91, 0x37, 0x8d, 0x0d, 0x78,
		0xbf, 0x49, 0x11, 0xf4, 0x23, 0xe5, 0xce, 0x3b,  0x55, 0xbc, 0xa2, 0x57, 0xe8, 0x22, 0x74, 0xce,
	}, {
		0x2c, 0xea, 0xc1, 0xbf, 0x4a, 0x24, 0x1f, 0xc2,  0x79, 0x47, 0xa2, 0x7c, 0xb6, 0xd9, 0x68, 0x15,
		0x80, 0x56, 0x5d, 0x01, 0x33, 0xfd, 0xf4, 0xae,  0xde, 0x30, 0x07, 0x9b, 0xe5, 0x83, 0x9b, 0x68,
		0x49, 0xb4, 0x2e, 0x83, 0x1f, 0xc2, 0xb5, 0x7c,  0xa2, 0x19, 0xd8, 0xe5, 0x7c, 0x2f, 0x83, 0xda,
		0xf7, 0x6b, 0x90, 0xfe, 0xc4, 0x01, 0x5a, 0x97,  0x61, 0xa6, 0x3d, 0x40, 0x0b, 0x58, 0xe6, 0x3d,
	}, {
		0x4d, 0xd1, 0xb2, 0x0f, 0x28, 0xbd, 0xe4, 0x78,  0xf6, 0x4a, 0x0f, 0x93, 0x8b, 0x17, 0xd1, 0xa4,
		0x3a, 0xec, 0xc9, 0x35, 0x93, 0x56, 0x7e, 0xcb,  0x55, 0x20, 0xa0, 0xfe, 0x6c, 0x89, 0x17, 0x62,
		0x17, 0x62, 0x4b, 0xb1, 0xb4, 0xde, 0xd1, 0x87,  0xc9, 0x14, 0x3c, 0x4a, 0x7e, 0xa8, 0xe2, 0x7d,
		0xa0, 0x9f, 0xf6, 0x5c, 0x6a, 0x09, 0x8d, 0xf0,  0x0f, 0xe3, 0x53, 0x25, 0x95, 0x36, 0x28, 0xcb,
	}
};

/*-----------------
 *	long data get
 */
static unsigned int getlong(unsigned char *p)
{
  return *p+p[1]*256+(p[2]+p[3]*256)*65536;
}

/*==========================================
 *	File List : Hash make
 *------------------------------------------
 */
static int filehash(const wchar_t *fname_)
{
	unsigned int   hash  = 0;
	unsigned char *fname = (unsigned char*)fname_;
	while(*fname) {
		hash = ((hash<<1)+(hash>>7)*9+tolower(*fname));
		fname++;
	}
	return hash & 255;
}

/*==========================================
 *	Grf data decode : Subs
 *------------------------------------------
 */
static void NibbleSwap(unsigned char *Src, int len)
{
	for(;0<len;len--,Src++) {
		*Src = (*Src>>4) | (*Src<<4);
	}
}

static void BitConvert(unsigned char *Src,char *BitSwapTable)
{
	int lop,prm;
	unsigned char tmp[8];
	*(unsigned long*)tmp=*(unsigned long*)(tmp+4)=0;
	for(lop=0;lop!=64;lop++) {
		prm = BitSwapTable[lop]-1;
		if (Src[(prm >> 3) & 7] & BitMaskTable[prm & 7]) {
			tmp[(lop >> 3) & 7] |= BitMaskTable[lop & 7];
		}
	}
	*(unsigned long*)Src     = *(unsigned long*)tmp;
	*(unsigned long*)(Src+4) = *(unsigned long*)(tmp+4);
}

static void BitConvert4(unsigned char *Src)
{
	int lop,prm;
	unsigned char tmp[8];
	tmp[0] = ((Src[7]<<5) | (Src[4]>>3)) & 0x3f;	// ..0 vutsr
	tmp[1] = ((Src[4]<<1) | (Src[5]>>7)) & 0x3f;	// ..srqpo n
	tmp[2] = ((Src[4]<<5) | (Src[5]>>3)) & 0x3f;	// ..o nmlkj
	tmp[3] = ((Src[5]<<1) | (Src[6]>>7)) & 0x3f;	// ..kjihg f
	tmp[4] = ((Src[5]<<5) | (Src[6]>>3)) & 0x3f;	// ..g fedcb
	tmp[5] = ((Src[6]<<1) | (Src[7]>>7)) & 0x3f;	// ..cba98 7
	tmp[6] = ((Src[6]<<5) | (Src[7]>>3)) & 0x3f;	// ..8 76543
	tmp[7] = ((Src[7]<<1) | (Src[4]>>7)) & 0x3f;	// ..43210 v

	for(lop=0;lop!=4;lop++) {
		tmp[lop] = (NibbleData[lop][tmp[lop*2]] & 0xf0)
		         | (NibbleData[lop][tmp[lop*2+1]] & 0x0f);
	}

	*(unsigned long*)(tmp+4)=0;
	for(lop=0;lop!=32;lop++) {
		prm = BitSwapTable3[lop]-1;
		if (tmp[prm >> 3] & BitMaskTable[prm & 7]) {
			tmp[(lop >> 3) + 4] |= BitMaskTable[lop & 7];
		}
	}
	*(unsigned long*)Src ^= *(unsigned long*)(tmp+4);
}

static void decode_des_etc(unsigned char *buf,int len,int type,int cycle)
{
	int lop,cnt=0;
	if(cycle<3) cycle=3;
	else if(cycle<5) cycle++;
	else if(cycle<7) cycle+=9;
	else cycle+=15;

	for(lop=0;lop*8<len;lop++,buf+=8) {
		if(lop<20 || (type==0 && lop%cycle==0)){ // des
			BitConvert(buf,BitSwapTable1);
			BitConvert4(buf);
			BitConvert(buf,BitSwapTable2);
		} else {
			if(cnt==7 && type==0){
				int a;
				unsigned char tmp[8];
				*(unsigned long*)tmp     = *(unsigned long*)buf;
				*(unsigned long*)(tmp+4) = *(unsigned long*)(buf+4);
				cnt=0;
				buf[0]=tmp[3];
				buf[1]=tmp[4];
				buf[2]=tmp[6];
				buf[3]=tmp[0];
				buf[4]=tmp[1];
				buf[5]=tmp[2];
				buf[6]=tmp[5];
				a=tmp[7];
				if(a==0x00) a=0x2b;
				else if(a==0x2b) a=0x00;
				else if(a==0x01) a=0x68;
				else if(a==0x68) a=0x01;
				else if(a==0x48) a=0x77;
				else if(a==0x77) a=0x48;
				else if(a==0x60) a=0xff;
				else if(a==0xff) a=0x60;
				else if(a==0x6c) a=0x80;
				else if(a==0x80) a=0x6c;
				else if(a==0xb9) a=0xc0;
				else if(a==0xc0) a=0xb9;
				else if(a==0xeb) a=0xfe;
				else if(a==0xfe) a=0xeb;
				buf[7]=a;
			}
			cnt++;
		}
	}
}

/*==========================================
 *	File List : File find
 *------------------------------------------
 */
FILELIST *filelist_find(struct io_grf_data* grf,const wchar_t *fname)
{
	int hash;
	if(grf->filelist == NULL) {
		return NULL;
	}
	hash = grf->filelist_hash[filehash(fname)];
	while(hash>=0) {
		if(grf->filelist[hash].fn == NULL) {
			return NULL;
		} else if(wcscmp(grf->filelist[hash].fn,fname)==0) {
			break;
		}
		hash = grf->filelist[hash].next;
	}

	return (hash>=0)? &grf->filelist[hash] : NULL;
}

/*==========================================
 *	File List : Filelist add
 *------------------------------------------
 */
#define	FILELIST_ADDS	1024	// t@CXg

static FILELIST* filelist_add(struct io_grf_data* grf,FILELIST *entry)
{
	int hash;

	if (grf->filelist_entrys>=FILELIST_LIMIT) {
		console_outputf("filelist limit : filelist_add\n");
		exit(1);
	}

	if (grf->filelist_entrys >= grf->filelist_maxentry) {
		 grf->filelist = (FILELIST*)realloc(
			grf->filelist,(grf->filelist_maxentry+FILELIST_ADDS)*sizeof(FILELIST)
		);
		memset(grf->filelist + grf->filelist_maxentry,'\0',FILELIST_ADDS * sizeof(FILELIST));
		grf->filelist_maxentry += FILELIST_ADDS;
	}

	memcpy( &grf->filelist[grf->filelist_entrys], entry, sizeof(FILELIST) );

	hash = filehash(entry->fn);
	grf->filelist[grf->filelist_entrys].next = grf->filelist_hash[hash];
	grf->filelist_hash[hash] = grf->filelist_entrys;

	grf->filelist_entrys++;

	return &grf->filelist[grf->filelist_entrys-1];
}

/***********************************************************
 ***                  Grfio Sobroutines                  ***
 ***********************************************************/

/*==========================================
 *	Grfio : Resource file size get
 *------------------------------------------
 */
int io_grf_size(struct io_grf_data* grf,const wchar_t *fname)
{
	FILELIST *entry;

	entry = filelist_find(grf,fname);

	if (entry==NULL) {	// LocalFileCheck
		return 0;
	}
	return entry->declen;
}

/*==========================================
 *	Grfio : Resource file read & size get
 *------------------------------------------
 */
 
void* io_grf_reads(struct io_grf_data* grf,const wchar_t *fname, int *size)
{
	unsigned char *buf=NULL,*buf2=NULL;
	FILELIST *entry;

	entry = filelist_find(grf,fname);

	if (entry!=NULL) {
		// Archive[GRF] File Read
		buf = (char *)calloc(1,entry->srclen_aligned+1024);

		io_file_seek(grf->file,entry->srcpos);
		io_file_read(grf->file,buf,entry->srclen_aligned);
		buf2=(char *)calloc(1,entry->declen+1024);
		if(entry->type==1 || entry->type==3 || entry->type==5) {
			unsigned long len;
			if (entry->cycle>=0) {
				decode_des_etc(buf,entry->srclen_aligned,entry->cycle==0,entry->cycle);
			}
			len=entry->declen;
			io_zlib_decode(buf2,&len,buf,entry->srclen);
			if((int)len!=entry->declen) {
				console_outputf("decode_zip size miss match err: %d != %d\n",(int)len,entry->declen);
				goto errret;
			}
		} else {
			memcpy(buf2,buf,entry->declen);
		}
		free(buf);
	}
	if (size!=NULL && entry!=NULL)
		*size = entry->declen;
	return buf2;
errret:
	if (buf!=NULL) free(buf);
	if (buf2!=NULL) free(buf2);
	return NULL;
}

/*==========================================
 *	Resource filename decode
 *------------------------------------------
 */
static unsigned char * decode_filename(unsigned char *buf,int len)
{
	int lop;
	for(lop=0;lop<len;lop+=8) {
		NibbleSwap(&buf[lop],8);
		BitConvert(&buf[lop],BitSwapTable1);
		BitConvert4(&buf[lop]);
		BitConvert(&buf[lop],BitSwapTable2);
	}
	return buf;
}

/*==========================================
 * Grfio : Entry table read
 *------------------------------------------
 */

struct io_grf_data* io_grf_open(struct io_data* io,const wchar_t *gfname)
{
	unsigned char grf_header[0x2e];
	int lop,entry,entrys,ofs;
	unsigned char *fname;
	unsigned char *grf_filelist;
	struct io_grf_data* grf;

	grf = (struct io_grf_data*)calloc(1,sizeof(struct io_grf_data));
	if(grf == NULL) {
		return NULL;
	}
	grf->file = io_file_readopen(gfname);
	if(grf->file == NULL) {
		console_outputwf(_T("io_grf_open: %s not found\n"),gfname);
		free(grf);
		return NULL;
	}

	{
		int lop;
		for(lop=0;lop<256;lop++)
			grf->filelist_hash[lop]=-1;
	}

	grf->grf_size = io_file_size2(grf->file);
	io_file_read(grf->file,grf_header,0x2e);
	if(strcmp(grf_header,"Master of Magic")){
		io_file_close(grf->file);
		free(grf);
		console_outputwf(_T("io_grf_open: %s read error\n"),gfname);
		return NULL;
	}
	io_file_seek(grf->file,io_file_tell(grf->file) + getlong(grf_header+0x1e));
	grf->grf_version = getlong(grf_header+0x2a) >> 8;

	if (grf->grf_version==0x01) {
		//****** Grf version 01xx ******
		int list_size = grf->grf_size - io_file_tell(grf->file);
		grf_filelist = (char *)calloc(1,list_size);
		io_file_read(grf->file,grf_filelist,list_size);

		entrys = getlong(grf_header+0x26) - getlong(grf_header+0x22) - 7;

		// Get an entry
		for(entry=0,ofs=0;entry<entrys;entry++){
			int ofs2,srclen,srccount,type;
			char *period_ptr;
			FILELIST aentry;
			
			ofs2 = ofs+getlong(grf_filelist+ofs)+4;
			type = grf_filelist[ofs2+12];
			if( type==0 ){
				// Directory Index ... skip
				;
			} else {
				fname = decode_filename(grf_filelist+ofs+6,grf_filelist[ofs]-6);
				if(strlen(fname)>sizeof(aentry.fn)-1){
					console_outputf("io_grf_open: file name too long : %s\n",fname);
					free(grf_filelist);
					exit(1);
				}
				srclen=0;
				if((period_ptr=strrchr(fname,'.'))!=NULL){
					for(lop=0;lop<4;lop++) {
						if(strcmp(period_ptr,".gnd\0.gat\0.act\0.str"+lop*5)==0)
							break;
					}
					srclen=getlong(grf_filelist+ofs2)-getlong(grf_filelist+ofs2+8)-715;
					if(lop==4) {
						for(lop=10,srccount=1;srclen>=lop;lop=lop*10,srccount++);
					} else {
						srccount=0;
					}
				} else {
					srccount=0;
				}
				aentry.srclen         = srclen;
				aentry.srclen_aligned = getlong(grf_filelist+ofs2+4)-37579;
				aentry.declen         = getlong(grf_filelist+ofs2+8);
				aentry.srcpos         = getlong(grf_filelist+ofs2+13)+0x2e;
				aentry.cycle          = srccount;
				aentry.type           = type;
				if(!memcmp(fname,"data\\",5)) {
					io_mbcs_to_unicode(io,aentry.fn,fname+5);
				} else {
					io_mbcs_to_unicode(io,aentry.fn,fname);
				}
				filelist_add(grf,&aentry);
			}
			ofs = ofs2 + 17;
		}
		free(grf_filelist);
	} else if (grf->grf_version==0x02) {	//****** Grf version 02xx ******
		unsigned char eheader[8];
		unsigned char *rBuf;
		unsigned long rSize,eSize;
		int list_size;

		io_file_read(grf->file,eheader,8);
		rSize = getlong(eheader);	// Read Size
		eSize = getlong(eheader+4);	// Extend Size

		if ((int)rSize > grf->grf_size - io_file_tell(grf->file)) {
			io_file_close(grf->file);
			console_outputf("io_grf_open: Illegal data format : grf compress entry size\n");
			return NULL;
		}
		
		rBuf = (char *)calloc(1,rSize);	// Get a Read Size
		grf_filelist = (char *)calloc(1,eSize);	// Get a Extend Size
		io_file_read(grf->file,rBuf,rSize);
		io_zlib_decode(grf_filelist,&eSize,rBuf,rSize);	// Decode function
		list_size = eSize;
		free(rBuf);
		
		entrys = getlong(grf_header+0x26) - 7;
		
		// Get an entry
		for(entry=0,ofs=0;entry<entrys;entry++){
			int ofs2,srclen,srccount,type;
			FILELIST aentry;
			
			fname = grf_filelist+ofs;
			if (strlen(fname)>sizeof(aentry.fn)-1) {
				console_outputf("io_grf_open: file name too long : %s\n",fname);
				free(grf_filelist);
				exit(1);
			}
			ofs2 = ofs+strlen(grf_filelist+ofs)+1;
			type = grf_filelist[ofs2+12];
			if(type==1 || type==3 || type==5) {
				srclen=getlong(grf_filelist+ofs2);
				if (grf_filelist[ofs2+12]==3) {
					for(lop=10,srccount=1;srclen>=lop;lop=lop*10,srccount++);
				} else if (grf_filelist[ofs2+12]==5) {
					srccount = 0;
				} else {	// if (grf_filelist[ofs2+12]==1) {
					srccount = -1;
				}
			
				aentry.srclen         = srclen;
				aentry.srclen_aligned = getlong(grf_filelist+ofs2+4);
				aentry.declen         = getlong(grf_filelist+ofs2+8);
				aentry.srcpos         = getlong(grf_filelist+ofs2+13)+0x2e;
				aentry.cycle          = srccount;
				aentry.type           = type;
				if(!memcmp(fname,"data\\",5)) {
					io_mbcs_to_unicode(io,aentry.fn,fname+5);
				} else {
					io_mbcs_to_unicode(io,aentry.fn,fname);
				}
				filelist_add(grf,&aentry);
			}
			ofs = ofs2 + 17;
		}
		free(grf_filelist);
	} else {
		//****** Grf Other version ******
		io_file_close(grf->file);
		free(grf);
		console_outputf("io_grf_open: not support grf versions : %04x\n",getlong(grf_header+0x2a));
		return NULL;
	}
	return grf;
}

void io_grf_close(struct io_grf_data* grf) {
	if(grf == NULL) return;
	free(grf->filelist);
	grf->filelist = NULL;
	grf->filelist_entrys   = 0;
	grf->filelist_maxentry = 0;
	io_file_close(grf->file);
	free(grf);
}

const wchar_t* io_grf_find(struct io_find* find) {
	struct io_grf_data* grf = find->io->read_grf;
	if(find->pos < grf->filelist_entrys) {
		return grf->filelist[find->pos++].fn;
	} else {
		return NULL;
	}
}

