#ifndef _RSW_H_
#define _RSW_H_

// 168Byte
struct rsw_head {
	char	FileType[4];
	WORD	magic;
	char	INIFileName[40];
	char	GNDFileName[40];
	char	GATFileName[40];
	char	SCRFileName[40];
};

// Padding΍ŕ
struct rsw_info {
	float	WaterHeight;
	DWORD	WaterType;
	float	WaterWave_Power;
	float	WaterWave_Speed;
	float	WaterWave_Height;
	float	LightAmbient_R;
	float	LightAmbient_G;
	float	LightAmbient_B;
	float	LightDiffuse_R;
	float	LightDiffuse_G;
	float	LightDiffuse_B;
	float	Shadow_R;
	float	Shadow_G;
	float	Shadow_B;
	float	Shadow_A;
	float	unknown1;
	float	unknown2;
	float	unknown3;
	float	unknown4;
	long	ModelCount;
};

struct rsw_object {
	int  type;
	int  len;
	char *buf;
};

struct RO_POSITION {
	float pos_x;
	float pos_y;
	float pos_z;
	float rot_x;
	float rot_y;
	float rot_z;
	float size_x;
	float size_y;
	float size_z;
};

struct rsw_object_t01 {
	char	LayerName[24];
	char	unknown[16];
	char	unknown2[12];
	char	RSMName[36];
	char	unknown3[44];
	char	ModelType[12];
	char	unknown4[68];
	struct RO_POSITION	pos;
};

struct rsw_data {
	struct rsw_head head;
	struct rsw_info info;
	struct rsw_object *obj;
	int    obj_max;
	int    obj_len[16];
	char  *extra_data;
	int    extra_len;
};

void rsw_output_map(struct gmap_data* map,struct io_data* io,wchar_t *file_pre);
void rsw_check(struct io_data* io,const wchar_t *file,int extra_info);
void rsw_free(struct rsw_data *rsw);
struct rsw_data *rsw_load(struct io_data* io,const wchar_t* file);
void rsw_save(struct rsw_data* rsw,struct io_data *io,const wchar_t *file);

#endif
