// gmap.cpp : DLL AvP[Vp̃Gg |Cg`܂B
//

#include <stdio.h>
#include <windows.h>
#include "gmap.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

struct Platinum_Info {
	char version[128];
	char format[128];
	int  support; // 1:import 2:export 3:both import and export
};

__declspec(dllexport) void __cdecl GetPlatinumPluginInfo(struct Platinum_Info *info) {
	strcpy(info->version,"Ragnarok Map Export Plugin 2005 (c) End_of_exam");
	strcpy(info->format ,"Ragnarok Map (*.rsw)|*.rsw");
	info->support = 2;
}

__declspec(dllexport) int __cdecl IsSupported(const char *file) {
	// return 0; // support
	return 1; // not support
}

struct Platinum_Head {
	int mapsize_x;
	int mapsize_y;
	char chipsize_x;
	char chipsize_y;
	char layer_count;
	char layer_bits;
};

__declspec(dllexport) int __cdecl Export(
	HWND hWnd,const char *file,struct Platinum_Head* head,
	int (__stdcall *dummy) (int a,int b,int c)
) {
	HANDLE ppj_dll = LoadLibrary("plugins\\ppj.dll");
	int  (__cdecl *export) (
		HWND hWnd,const char *file,struct Platinum_Head* head,
		int (__stdcall *dummy) (int a,int b,int c)
	);
	char file_tmp[256];
	char systmp[512];
	int  ret;
	const char* z1,*z2;
	if(!ppj_dll) {
		MessageBox(hWnd,"Can't load ppj.dll","gmap.dll",MB_OK);
		return 1;
	}
	(FARPROC)export = GetProcAddress(ppj_dll,"Export");
	if(export == NULL) {
		MessageBox(hWnd,"Can't load ppj.dll","gmap.dll",MB_OK);
		FreeLibrary(ppj_dll);
		return 1;
	}
	z1 = strrchr(file,'.');
	z2 = strrchr(file,'\\');
	if(z1 == NULL || (z2 && z1 < z2)) {
		sprintf(file_tmp,"%s.ppj",file);
	} else {
		memcpy(file_tmp,file,z1 - file);
		strcpy(file_tmp + (z1 - file),".ppj");
	}
	ret = export(hWnd,file_tmp,head,dummy);
	FreeLibrary(ppj_dll);
	if(ret) return ret;
	sprintf(systmp,"igun -map \"%s\"",file_tmp);
	ret = system(systmp);
	if(ret != 0) {
		MessageBox(hWnd,"Can't exec igun.exe","gmap.dll",MB_OK);
		return 1;
	}
	return 0; // success
}
